#! /bin/sh
eval '(exit $?0)' && eval 'PERL_BADLANG=x;PATH="$PATH:.";export PERL_BADLANG\
;exec perl -x -S -- "$0" ${1+"$@"};#'if 0;eval 'setenv PERL_BADLANG x\
;setenv PATH "$PATH":.;exec perl -x -S -- "$0" $argv:q;#'.q
#!perl -w
+push@INC,'.';$0=~/(.*)/s;do(index($1,"/")<0?"./$1":$1);die$@if$@__END__+if 0
;#Don't touch/remove lines 1--7: http://www.inf.bme.hu/~pts/Magic.Perl.Header
#
# ccs_extract.pl -- extract and fix `ccs etc. from TeX documents
# by pts@fazekas.hu at Fri Dec 26 12:02:12 CET 2003
#
# Imp: ability to specify active char: ` " '
# Imp: make program breakable with Ctrl-<C>, SIGINT.
# Imp: make it idempotent, parse each word once in pts_diploma.tex
#
use integer;
use strict;

my %AV=qw{a a1  a2 e e1  e2 i i1  i2 o o1  o2  o3  o4
  u u1  u2  u3  u4};
#** @return accented sort value of the string
sub av($) {
  my $S=$_[0];
  $S=~s@([aeiou])@$AV{$1}@g;
  $S
}

die "Usage: $0 <main-filename.tex> [<other-filename.tex ...]\n" if !@ARGV;


#** Skipping between \documentclass and \begin{document}
my $is_skipping=0;

#** $hints{'leggyorsabban'}='le``ggyorsabban';
#** As read from lines beginning with `%`% '
my %hints;
my %hints_add;
my %totals;

sub comment_to_db() {
  return 0 if !/^%`% ([a-z`]+)\s*\d*\s*$/;
  my($k,$v)=($1,$1);
  $k=~y@`@@d;
  # Imp: verify lowercase
  if (exists $hints{$k} and $hints{$k} ne $v) { print STDERR "warning: ignoring duplicate $v, keeping $hints{$k}\n" }
                    else { $hints{$k}=$v }
  1
}

sub simplify_line() {
  # Imp: \begin{figure}[tbp]
  # Imp: multi-line \documentclass etc.
  # Imp: \hrule `plus' `minus' etc.
  s@\A%.*@@s; # comment at BOL
  s@([^\\])(?:\\\\)*%.*@$1@s; # comment not at bol
  # if (!/\s\Z(?!\n)) { # continue in next line after comment
  # ^^^ Imp: don't continue after `\foo%', but continue after `\foo'
  # ^^^ Imp: also continue after `\def\foo{a,b,c,'
  # Dat: some documents have extra \documentclass
  $is_skipping=1 if $is_skipping==0 and s@\\document(?:class|style)(?![a-zA-Z\@]).*@ @gs;
  $is_skipping=2 if s@\A.*?\\begin\s*\{document\}@ @gs;
  s@\\(?:begin|end|usepackage|documentclass|pagestyle|thispagestyle
    |[Aa]?(?:page)?ref|[Aa]?cite|refstruc|label|bibliography(?:style)?
    |special|message|errmessage|typeout|index
  )\s*\{[^}]*\}@ @gx;
  s@\\(?:documentclass|usepackage)\s*\[[^\]]*\]\s*\{[^}]*\}@ @gx;
  s@\\csname(?![a-zA-Z\@]).*?\\endcsname(?![a-zA-Z\@])@ @gs;
  s@\\(?:[^a-zA-Z\@]|[a-zA-Z\@]+\s*)@ @g; # remove control sequences
  $_="" if $is_skipping==1;
  # ^^^ Imp: don't skip for \title{...} and \begin{abstract}
}

sub simplify_line_nl() {
  # Imp: \begin{figure}[tbp]
  # Imp: multi-line \documentclass etc.
  # Imp: \hrule `plus' `minus' etc.
  s@\A(%.*)@"\n"x length$1@se; # comment at BOL
  s@([^\\])((?:\\\\)*%.*)@$1."\n"x length$2@se; # comment not at bol
  # if (!/\s\Z(?!\n)) { # continue in next line after comment
  # ^^^ Imp: don't continue after `\foo%', but continue after `\foo'
  # ^^^ Imp: also continue after `\def\foo{a,b,c,'
  $is_skipping=1 if $is_skipping==0 and s@(\\document(?:class|style)(?![a-zA-Z\@]).*)@"\n"x length$1@gse;
  $is_skipping=2 if s@\A(.*?\\begin\s*\{document\})@"\n"x length$1@gse;
  # ^^^ Imp: don't skip for \title{...} and \begin{abstract}
  if ($is_skipping==1) { $_="\n"x length$_ }
  else {
    s@(\\(?:begin|end|usepackage|documentclass|pagestyle|thispagestyle
      |[Aa]?(?:page)?ref|[Aa]?cite|refstruc|label|bibliography(?:style)?
      |special|message|errmessage|typeout|index
    )\s*\{[^}]*\})@"\n"x length$1@gxe;
    s@(\\(?:documentclass|usepackage)\s*\[[^\]]*\]\s*\{[^}]*\})@"\n"x length$1@gxe;
    s@(\\csname(?![a-zA-Z\@]).*?\\endcsname(?![a-zA-Z\@]))@"\n"x length$1@gse;
    s@(\\(?:[^a-zA-Z\@]|[a-zA-Z\@]+\s*))@"\n"x length$1@ge; # remove control sequences
  }
}

sub words_to_db() {
  my $w;
  ##print "$. ($_)\n";
  while (m@([a-zA-Z`]+)@g) {
    # Imp: don't find only `hnlich' of hnlich
    $w=$1;
    next unless length($w)>3 and $w!~y@`@@;
    next unless $w=~/(?:ccs|CCS|ddzs?|DDZS?|ggy|GGY|lly|LLY|nny|NNY|ssz|SSZ|tty|TTY|zzs|ZZS)/;
    # ^^^ Imp: now PuCcs won't be accepted, but PuCCSoSsz will :-(
    $w=~y@A-Z@a-z@;
    my $v=$w;
    $v=~s/(ccs|ddzs?|ggy|lly|nny|ssz|tty|zzs)(?=[aeiou])/``$1/g; # Dat: prefix insertion
    # ^^^ Dat: `(?=...) is to avoid me``ggy and sze``nnycmoldal
    #if ($v!~/``ddzs\Z(?!\n)/ and $v!~/``...\Z(?!\n)/s) {
    if ($v=~y@`@@) { # BUGFIX at Tue May 18 11:47:22 CEST 2004
      ##print STDERR "+ $v $.\n";
      $hints_add{$w}=$v;
      $totals{$w}++;
    }
  }
}

my $last_real_ofs=0;
my $mainfn=shift @ARGV;
{ die "$0: opening $mainfn: $!\n" unless open M, "+< $mainfn";
  $is_skipping=0;
  while (<M>) {
    next if comment_to_db();
    $last_real_ofs=tell M;
    simplify_line();
    words_to_db() if length;
  }
  die unless seek M, 0, 0;
}
for my $fn (@ARGV) {
  die "$0: opening $fn: $!\n" unless open F, "< $fn";
  $is_skipping=0;
  while (<F>) {
    next if comment_to_db();
    simplify_line();
    words_to_db() if length;
  }
  die unless close F;
}
while (my($k,$v)=each %hints_add) { $hints{$k}=$v if !exists $hints{$k} }

sub transform_line() {
  return $_ if /^%`% ([a-z']+)\s*\d*\s*$/;
  my $orig=$_;
  simplify_line_nl(); # convert unnecessary chars to newlines
  my $repl="";
  my $w;
  my $origbeg=0;
  while (m@(\n+)|([^\na-zA-Z`]+)|([a-zA-Z`]+)@g) {
    # Imp: don't find only `hnlich' of hnlich
    if (defined $1) {
      $repl.=substr($orig,$origbeg,length($1));
      $origbeg+=length($1);
    } elsif (defined $2) {
      $repl.=$2;
      $origbeg+=length($2);
    } else {
      $origbeg+=length($3);
      $w=$3;
      if (length($w)>3 and $w!~y@`@@ and $w=~/(?:ccs|CCS|ddzs?|DDZS?|ggy|GGY|lly|LLY|nny|NNY|ssz|SSZ|tty|TTY|zzs|ZZS)/) {
        ##print STDERR "$w $.\n";
        my $lc=$w; $lc=~y@A-Z@a-z@;
        if (exists $hints{$lc}) {
          my $h=$hints{$lc}; $h=~s@``@@g;
          if ($h ne $lc) { # insert some "`" marks
            ## print STDERR "$w -> $h\n";
            while ($h=~/([`]*)(`+)/g) {
              ##print STDERR "substr(\$w,".pos($h)."-".length($2).",0)='$2';\n";
              substr($w,pos($h)-length($2),0)=$2;
              # $w2.=substr($w,pos($h)-length($1)-length($2),length($1)).$2;
              # ^^^ Dat: substr: keep upper/lower case intact
            }
            $totals{$lc}--;
            # $w=$w2;
          }
        }
      }
      $repl.=$w;
    }
  } ## WHILE
  $repl
}

#** Keeps the whole replacement contents of mainfn in memory.
my $out="";

$is_skipping=0;
$.=0;
while (<M>) {
  $out.=transform_line();
  last if $last_real_ofs==tell(M);
}
$out.="\n" if substr($out,-1)ne"\n";

die unless seek M, 0, 0;
die unless print M $out;
# Imp: precalc av(...)
for my $w (sort { av($a) cmp av($b) }  keys %hints) {
  die unless print M exists $totals{$w} ? "%`% $hints{$w} $totals{$w}\n" : "%`% $hints{$w}\n"
}
die unless truncate M, tell M;
die unless close M;

for my $fn (@ARGV) {
  die "$0: opening $fn: $!\n" unless open F, "+< $fn";
  $is_skipping=0;  $out="";
  while (<F>) { $out.=transform_line() }
  $out.="\n" if substr($out,-1)ne"\n";
  die unless seek F, 0, 0;
  die unless print F $out;
  die unless truncate F, tell F;
  die unless close F;
}

__END__
